using LinearAlgebra

function gram_schmidt(a, tol=1e-10; modified=false)
    q = [];
    for i = 1:length(a)
        qtilde = a[i];
        for j = 1:i-1
            if modified
                qtilde = qtilde - (q[j]'*qtilde)*q[j];
            else
                qtilde -= (q[j]'*a[i])*q[j];
            end
        end
        if norm(qtilde)<tol
            println("Vectors are linearly dependent.");
            return q;
        end
        push!(q, qtilde/norm(qtilde));
    end
    return q;
end


n=5;
a=[]
for i in 1:n
    push!(a,1.0./(i.+(1:n).-1))
    # push!(a,rand(3))
end
# a[n] = copy(a[n-1]); a[n][n] += 1e-5;
# @show a

q = gram_schmidt(a, 1e-15; modified=true)
Q = hcat(q...);
@show norm(Q*Q'-I,Inf)
